#!/usr/bin/perl
# assign p-values to predicted TFBSs

if( $#ARGV != 2 ){
	print "Usage: input background output\n";
	exit;
}

#
# read in input and background
#
open(IN,"$ARGV[0]");
@hits = ();
$i=0;
while($line = <IN> ){
	chomp($line);
	@parts = split(' ',$line);
	$i++;
	$info = {};
	$info->{line} = $line;
	$info->{score} = $parts[$#parts];
	$info->{ind} = $i;
	push(@hits, $info);
}
close(IN);

open(IN,"$ARGV[1]");
@bk = ();
while($line = <IN>){
	chomp($line);
	push(@bk, $line);
}

#
# sort both by score
#
@hits = sort{ $a->{score} <=> $b->{score} } @hits;
@bk = sort{ $a <=> $b } @bk;

#
# go through all hits and add p-value
#
$j=0;
$end = $#bk;
for($i=0; $i<= $#hits; $i++){
	while( $bk[$j] < $hits[$i]->{score} && $j<= $end ){$j++;}
	if( $bk[$j] >= $hits[$i]->{score} ){
		if( $j==0 ){
			$hits[$i]->{pval} = "1.0";
		}
		else{
			$hits[$i]->{pval} = sprintf("%0.1e", ($#bk+1 - ($j-1) )/($#bk+1) );
		}
	}
	else{
		$hits[$i]->{pval} = sprintf("<%0.1e", 1.0/($#bk+1) );
	}
}

#
# resort hits by index and print
#
@hits = sort{ $a->{ind} <=> $b->{ind} } @hits;

open(OUT,">$ARGV[2]");
for($i=0; $i<= $#hits; $i++){
	print OUT "$hits[$i]->{line} $hits[$i]->{pval}\n";
}
close(OUT);





