#!/usr/bin/perl
# uses the output of select_features.pl and a feature list to make a new, shorter feature list

if( $#ARGV != 2 ){
	print "Usage: features list_to_use output\n";
	exit;
}

#
# get max length of feature vectors
#
$lx = 0;
open(IN,"$ARGV[0]") || die "Can't open $ARGV[0]\n";
while($line = <IN>){
	chomp($line);
	@parts = split(' ', $line);
	($ind, $val) = split(':',$parts[$#parts]);
	if( $lx < $ind ){$lx=$ind;}
}
close(IN);

#
# read in training data (libSVM format)
#
@y = ();
@x = ();
open(IN,"$ARGV[0]") || die "Can't open $ARGV[0]\n";
while($line = <IN>){
	chomp($line);
	@parts = split(' ', $line);
	push(@y, $parts[0]);
	$j=1;
	@vec = ();
	for($i=1; $i<= $#parts; $i++){
		($ind, $val) = split(':',$parts[$i]);
		while($j< $ind){
			push(@vec, 0);
			$j++;
		}
		push(@vec, $val);
		$j++;
	}
	while($j<= $lx){
		push(@vec, 0);
		$j++;
	}
	push(@x, [@vec]);
	if( $#vec != $lx-1 ){
		print "Error in code: length of vector is not what it's supposed to be\n";
		exit;
	}
}
close(IN);
$nx = $#x+1;

#
# read in features to use
#
@useinds = ();
for($i=0; $i< $lx; $i++){
	push(@useinds, 0);
}

open(IN,"$ARGV[1]") || die "Can't open $ARGV[1]\n";
while($line = <IN>){
	chomp($line);
	@parts = split(' ', $line);
	$useinds[$parts[0]] = 1;
}
close(IN);

#
# print out new feature list
#
open(OUT,">$ARGV[2]");
for($j=0; $j< $nx; $j++){
	print OUT "$y[$j]";
	$k=1;
	for($i=0; $i< $lx; $i++){
		if( $useinds[$i] == 1 ){
			print OUT " $k:$x[$j][$i]";
			$k++;
		}
	}
	print OUT "\n";
}
close(OUT);











